#include "iogateway/PlainTextMessageIOGateway.h"

PlainTextMessageIOGateway ::
PlainTextMessageIOGateway(PortableDataIO * io) : AbstractMessageIOGateway(io), _currentSendLine(0), _currentSentOffset(0)
{
   // empty
}

PlainTextMessageIOGateway ::
~PlainTextMessageIOGateway()
{
   // empty
}

status_t 
PlainTextMessageIOGateway ::
DoOutput()
{
   const PortableMessage * msg = _currentSendingMessage.GetItemPointer();
   if (msg == NULL) 
   {
      (void) _outgoingMessages.RemoveHead(_currentSendingMessage);
      msg = _currentSendingMessage.GetItemPointer();
   }
   if (msg)
   {
      const char * line;
      if (msg->FindString(PR_NAME_TEXT_LINE, _currentSendingMessage, &line) == B_NO_ERROR)
      {
         const char * text = &line[_currentSendOffset];
         int len = strlen(text);  // one for the "\n" at the end
         ssize_t bytesWritten = _io->Write(&line[_currentSendOffset], len);
         if (bytesWritten > 0) 
         {
            _currentSendOffset += bytesWritten;
            if (_currentSendOffset
      }
      else
      {
         _currentSendingOffset = _currentSendLine = 0;
         PortableMessageRef empty;
         _currentSendLine = empty;
      }
   }
   return DoOutput();  // on to the next message
}

status_t 
PlainTextMessageIOGateway ::
DoInput()
{
}

bool 
PlainTextMessageIOGateway ::
HasBytesToOutput() const
{
   return ((_currentSendingMessage.GetItemPointer() != NULL)||(AbstractMessageIOGateway::HasBytesToOutput()));
}
