/* This file is Copyright 2001 Level Control Systems.  See the included LICENSE.txt file for details. */

#ifndef STORAGE_REFLECT_UTILS_H
#define STORAGE_REFLECT_UTILS_H

#include "string/PortableString.h"

// Miscellaneous helper functions that are useful on both client 
// and server sides can be placed here.

/** Returns a pointer into (path) after the (depth)'th '/' char
 *  @param depth the depth in the path to search for (0 == root, 1 == first level, 2 == second, etc.)
 *  @param path the path string (e.g. "/x/y/z/...") to search through
 *  @result a pointer into (path), or NULL on failure.
 */
const char * GetPathClause(int depth, const char * path);

/** Returns the depth of the given path.  (path) should start with a '/'
 *  @param path a string starting with '/'
 *  @return the number of clauses in (path).  (a.k.a the 'depth' of (path))
 */
int GetPathDepth(const char * path);

#endif
