/* This file is Copyright 2001 Level Control Systems.  See the included LICENSE.txt file for details. */

/******************************************************************************
/
/	File:		PortableMacros.h
/
/	Description:	Some macros that I like to use....
/
*******************************************************************************/

#ifndef _PORTABLEMACROS_H
#define _PORTABLEMACROS_H

#define MUSCLE_VERSION_STRING "1.60"

#ifndef NEW_H_NOT_AVAILABLE
# include <new.h>
#else
# define newnothrow new
#endif

#ifndef UNISTD_H_NOT_AVAILABLE
# include <unistd.h>
#endif

#include <stdio.h>
#include <stdlib.h>

#include "syslog/SysLog.h"

#define WARN_OUT_OF_MEMORY LogTime(MUSCLE_LOG_CRITICALERROR, "ERROR--OUT OF MEMORY!  (%s:%i)\n",__FILE__,__LINE__)

#ifndef newnothrow
#define newnothrow new (nothrow) 
#endif

#define MASSERT(x,msg) if(!(x)) {LogTime(MUSCLE_LOG_CRITICALERROR, "ASSERTION FAILED: (%s:%i) %s\n", __FILE__,__LINE__,msg); *((uint32 *)0) = 0xdeadbeef;}

#define UNLESS(x) if(!(x))
#define ARRAYITEMS(x) (sizeof(x)/sizeof(x[0]))  // returns # of items in array

#ifdef __BEOS__
# ifdef BONE
#  define closesocket close
# else
#  define BEOS_OLD_NETSERVER
# endif
#else
# define closesocket close
#endif

#endif /* _PORTABLEMACROS_H */

